//+------------------------------------------------------------------+
#property copyright "Daniel Jose"
#property indicator_chart_window
#property indicator_plots 0
//+------------------------------------------------------------------+
#include <Canvas\Canvas.mqh>
//+------------------------------------------------------------------+
#define _ToRadians(A) (A * (M_PI / 180.0))
#define _SizeLine 200
//+------------------------------------------------------------------+
CCanvas canvas;
//+------------------------------------------------------------------+
struct st_00
{
    int     x,
            y;
    double  Angle;
}global;
//+------------------------------------------------------------------+
void Func_01(void)
{
	int A[] {
              	-100,  150,
               	 -80,   50,
               	  30,  -80,
               	 100, -120
            };

    canvas.LineVertical(global.x, global.y - _SizeLine, global.y + _SizeLine, ColorToARGB(clrRoyalBlue, 255));
    canvas.LineHorizontal(global.x - _SizeLine, global.x + _SizeLine, global.y, ColorToARGB(clrRoyalBlue, 255));

    for (uint c0 = 0, c1 = 0; c1 < A.Size(); c0++)
	    canvas.FillCircle(global.x + A[c1++], global.y + A[c1++], 5, ColorToARGB(clrRed, 255));
}
//+------------------------------------------------------------------+
void NewAngle(const char direct, const double step = 1)
{
	canvas.Erase(ColorToARGB(clrWhite, 255));
   	Func_01();

    global.Angle = (MathAbs(global.Angle + (step * direct)) < 90 ? global.Angle + (step * direct) : global.Angle);
    canvas.TextOut(global.x + _SizeLine + 50, global.y, StringFormat("%.2f", MathAbs(global.Angle)), ColorToARGB(clrBlack));
    canvas.TextOut(global.x, global.y + _SizeLine + 50, StringFormat("f(x) = %.2fx", -MathTan(_ToRadians(global.Angle))), ColorToARGB(clrBlack));
    canvas.Line(
                global.x - (int)(_SizeLine * cos(_ToRadians(global.Angle))), 
                global.y - (int)(_SizeLine * sin(_ToRadians(global.Angle))), 
                global.x + (int)(_SizeLine * cos(_ToRadians(global.Angle))), 
                global.y + (int)(_SizeLine * sin(_ToRadians(global.Angle))), 
                ColorToARGB(clrForestGreen)
            );
	canvas.Update(true);
}
//+------------------------------------------------------------------+
int OnInit()
{	
    global.Angle = 0;
	global.x = (int)ChartGetInteger(0, CHART_WIDTH_IN_PIXELS, 0);
	global.y = (int)ChartGetInteger(0, CHART_HEIGHT_IN_PIXELS, 0);

	canvas.CreateBitmapLabel("BL", 0, 0, global.x, global.y, COLOR_FORMAT_ARGB_NORMALIZE);
    global.x /= 2;
    global.y /= 2;
		
    NewAngle(0);

	canvas.Update(true);
	
	return INIT_SUCCEEDED;
}
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total, const int prev_calculated, const int begin, const double &price[])
{
	return rates_total;
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id, const long &lparam, const double &dparam, const string &sparam)
{
    switch (id)
    {
        case CHARTEVENT_KEYDOWN:
            if (TerminalInfoInteger(TERMINAL_KEYSTATE_LEFT))
                NewAngle(-1);
            if (TerminalInfoInteger(TERMINAL_KEYSTATE_RIGHT))
                NewAngle(1);
            break;
    }
}
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
	canvas.Destroy();
}
//+------------------------------------------------------------------+